/*

DBSE 3
(c) 2000-2003 Andrea Rizzi
License: GPLv2 

*/

#include "database.h"

#include <qregexp.h>

#include <kapplication.h>
#include <kdebug.h>
#define i18n (const char*)






DataBase::DataBase(QString dbpath,QString dbname, QString dblang) : Db(0,DB_CXX_NO_EXCEPTIONS)
{
  
  filename=dbpath+"."+dblang+".db";
  database=dbname;
  
}

int DataBase::open(DBTYPE type,unsigned int flags)
{
  int ret;
  ret = Db::open((const char*)filename.local8Bit(),(const char *)database.local8Bit(),type,flags,0644);
  mytype=type;
  return ret;
}

unsigned int DataBase::getLast()
{
  if(mytype!=DB_RECNO)
    return 0;
  
  Dbc *cur;
  cursor(0,&cur,0);
  DBItemNum index;
  DBItemMainKey key;
  cur->get(&index,&key,DB_LAST);
  return index.getNum();

}
    




QueryResult::QueryResult(QString r)
{
  res=r;
}
QueryResult::QueryResult(QString r,QString o,int s)
{
  res=r;
  richr=r;
  orig=o;  
  richo=o;
  sco=s;
}
  
QueryResult::QueryResult()
{
  res="";
}
  



DataBaseInterface::DataBaseInterface()
{
  main = openMyDataBase("./testm","main","it",DB_BTREE);
  alpha = openMyDataBase("./testa","alpha","it",DB_BTREE);
  numindex = openMyDataBase("./testn","numindex","it",DB_RECNO);
  wordsindex = openMyDataBase("./testw","wordsindex","it",DB_BTREE);
  sentence = openMyDataBase("./tests","sentence","it",DB_BTREE);
  
  stopNow=false;
} 
DataBaseInterface::~DataBaseInterface()
{

  if(main){
    main->close(0); 
    delete main; 
  }    
  if(numindex){
    numindex->close(0); 
    delete numindex; 
  }
   
  if(alpha){
    alpha->close(0); 
    delete alpha; 
  } 
  if(wordsindex){
    wordsindex->close(0); 
    delete wordsindex; 
  } 
  if(sentence){
    sentence->close(0); 
    delete sentence; 
  } 
  
}

DataBase *DataBaseInterface::openMyDataBase(QString prefix,QString name,QString l,DBTYPE tt)
{

  DataBase *aDb = new DataBase(prefix,name,l);
  if(aDb==0){
    return 0;
  }
  else
    {
      if(aDb->open(tt)!=0)
	{
   
	  //ASK HERE, IF true....
	  if(true)
	    if(aDb->open(tt,DB_CREATE)!=0)
	      {
		return 0;
	      }
	    else
	      {
		return aDb;
	      } 
	}
  
    } 
  return aDb;
}    

/*
 *   query functions.
 * 
 */


DataBaseInterface::MainEntry DataBaseInterface::get(QString query,InfoFilter *filter)
{
  static int counter=1;
  counter++;
  DBItemMainKey k(query);	 
  DBItemMainData d;	 
  main->get(&k,&d);

  if(counter%5==0) kapp->processEvents(100);

  return qMakePair(k,d);  

}

DataBaseInterface::ResultList DataBaseInterface::exactMatch(QString query,InfoFilter *filter)
{
    ResultList res;
  MainEntry e=get(query,filter);
  
  QStringList trs=e.second.getTranslations();
  
  for(QStringList::iterator it=trs.begin();it!=trs.end();it++)
  {
      if(true)
      {
//	  if(counter%5==0) kapp->processEvents(100);
	  emit newResult(QueryResult(*it,e.first.getString(),100));  //I may need to disable it
      }
    res.push_back(QueryResult(*it));
  }      
  return res;
}

    
DataBaseInterface::ResultList DataBaseInterface::alphaMatch(QString query,InfoFilter *filter)
{
  ResultList res;
  DBItemMainKey *k = new DBItemMainKey(simple(query));	 
  DBItemMultiIndex *d = new DBItemMultiIndex();	 

  alpha->get(k,d);
 
  DBItemMultiIndex::IndexList il=d->getList();
  for(DBItemMultiIndex::IndexList::iterator it=il.begin();it!=il.end()&&!stopNow;it++)
    {
      numindex->get(*it,k);
      MainEntry e=get(k->getString(),filter);
      QStringList trs=e.second.getTranslations();
      for(QStringList::iterator it=trs.begin();it!=trs.end();it++)
      {		
	  emit newResult(QueryResult(format(simple(*it,true),query),e.first.getString(),98)); 
	  res.push_back(QueryResult(*it));
      }
   //   res+=exactMatch(k->getString(),filter);
    }
  delete d;
  delete k;
  return res;
}    


DataBaseInterface::ResultList DataBaseInterface::sentenceMatch(QString query,InfoFilter *filter)
{
  ResultList res;
  DBItemMainKey *k = new DBItemMainKey(simple(query));	 
  DBItemMultiIndex *d = new DBItemMultiIndex();	 

  wordsindex->get(k,d);
 
  DBItemMultiIndex::IndexList il=d->getList();
  for(DBItemMultiIndex::IndexList::iterator it=il.begin();it!=il.end()&&!stopNow;it++)
    {
      numindex->get(*it,k);
      MainEntry e=get(k->getString(),filter);
      QStringList trs=e.second.getTranslations();
      for(QStringList::iterator it=trs.begin();it!=trs.end()&&!stopNow;it++)
      {		
	  emit newResult(QueryResult(*it,e.first.getString(),98)); 
	  res.push_back(QueryResult(*it));
      }
  }
  delete d;
  delete k;
  return res;

}

DataBaseInterface::ResultList DataBaseInterface::wordsMatch(QString query,InfoFilter *filter)
{
  ResultList res;
  QStringList querywords = words(query);
  typedef QMap<QString,QValueList<unsigned int> > ResultMap;
  ResultMap rmap;  //result of words index query
  unsigned int notfound=0,frequent=0,nwords = querywords.count();
  
  //Get index list for each word
  for(QStringList::iterator it = querywords.begin(); it != querywords.end()&&!stopNow ;it++)
   { 
     DBItemMainKey *k = new DBItemMainKey(*it);	 
     DBItemMultiIndex *d = new DBItemMultiIndex();	 
     if(wordsindex->get(k,d)!=DB_NOTFOUND)
     {
	 rmap[k->getString()]=d->getList();
	 if(rmap[k->getString()].count()>1000)  //NORMALIZE THIS!!!
	 {
	     frequent++;
	 kdDebug(0) << "\""<<k->getString() << "\" is frequent" <<endl;
	 }
     }
	 else
       notfound++;
    

    delete k;
    delete d;
   }
  
		
  //

  QValueList<unsigned int>::iterator countpos[nwords+1];

  
  QValueList<unsigned int> il;
  for(int i = 0;i<=nwords&&!stopNow;i++) countpos[i]=il.end();

  unsigned int bestcount=0;
  while(!rmap.isEmpty())
  {
  unsigned int ref,count;
   ref=(unsigned int)-1;
   count=0;
   
    for(ResultMap::iterator it = rmap.begin();it!=rmap.end()&&!stopNow;it++)
     {
      unsigned int thisref=it.data().first();
      if(thisref<ref)
       {
          ref=thisref;
	  count=0;
       }
      if(thisref==ref)
      {
       count++;
      }
       
     }
    
     
    for(ResultMap::iterator it = rmap.begin();it!=rmap.end()&&!stopNow;)
    {
         it.data().remove(ref);
           
	 //kdDebug(0)<< ((frequent<(nwords-notfound)) && (it.data().count()>350)) <<endl;
	 if(it.data().isEmpty() || ((frequent<(nwords-notfound)) && (it.data().count()>1000)) )  //very dirty hack...
	 {

	   ResultMap::iterator it2=it;
           it++;
           rmap.remove(it2);
	 }
	else it++;
	 
    }

    //This should be configurable or optimized:
     if(count>=(nwords-notfound)*0.50 && count!=0)
       {
        il.insert(countpos[count],ref);
	
	for(unsigned int i = nwords;i>=count;i--) 
	 if(countpos[i]==countpos[count])
	  countpos[i]--;
	  
       }
    
    
  }     
     
  DBItemMainKey *k = new DBItemMainKey();	 
  
  //loop on number of words found
      int bestscore=0;
  
  for(unsigned int wf=nwords;wf>0;wf-- ){
      for(QValueList<unsigned int>::iterator it=countpos[wf];it!=countpos[wf-1];it++)
      { //loop on entries with same number of word found
      numindex->get(*it,k);
      
      MainEntry e=get(k->getString(),filter);
      QStringList trs=e.second.getTranslations();
      
      for(QStringList::iterator it=trs.begin();it!=trs.end()&&!stopNow;it++)
      {		
	  unsigned int winr=words(*it).count(); //words in result
	  //compute a score, lets kbabel sort now, it should be fast...
	  int score=90*wf/nwords-(signed int)90*(((nwords-winr)>0)?(nwords-winr):(winr-nwords))/(nwords*10);
	  if(score>bestscore) bestscore=score;
	  if(score>bestscore*0.40)
	  {
	      // kdDebug(0) << "s: "<<score << "  wf: "<<wf<<"  nwords: "<<nwords<<" winr:  "<<winr
	      //    <<" 90*wf/nwords: "<<90*wf/nwords << "  -:" <<  90*(((nwords-winr)>0)?(nwords-winr):(winr-nwords))/(nwords*10)<< endl;
	      QString ori=e.first.getString();
	      QString re=format(simple(*it,true),query);
	      QueryResult r(re,ori,score);
	      for(QStringList::iterator it = querywords.begin(); it != querywords.end()&&!stopNow ;it++){
		  ori=ori.replace(QRegExp(*it,false),"<font color=#000080><u><b>"+*it+"</b></u></font>");
	      }
	      r.setRichOriginal(ori);	
	      
	      emit newResult(r); 
	  }//res.push_back(QueryResult(*it));
      }	      
     }
  }	
  delete k;
  return res;

}
    
/*
 * put functions
 *                                              *
 */


bool DataBaseInterface::addEntry(QString original,QString translated,InputInfo *info,bool clean)
{
  DBItemMainKey  mk(original);
  DBItemMainData  md; 
 
  //try to get
  if(main->get(&mk,&md)==DB_NOTFOUND)
    {			
      //This is a new entry, create index entry
      DBItemNum *nind;
      int newid=numindex->getLast()+1;
      nind=new DBItemNum(newid);
      numindex->put(nind,&mk); 
      delete nind;
  
      md.clear();
      md.setIndexnumber(newid); 
  
  
      //Update secondary index alpha
      DBItemMainKey ka(simple(original));
      DBItemMultiIndex in;
      if(alpha->get(&ka,&in)==DB_NOTFOUND) in.clear()  ;
      //alpha->get(&ka,&in);
      in.addEntry(newid);
      alpha->put(&ka,&in);

      //Update words index
      QStringList ws=words(original);
      for(QStringList::iterator it = ws.begin(); it!=ws.end(); it++)
        {
           DBItemMainKey word(*it);
           DBItemMultiIndex win;
	   if(wordsindex->get(&word,&win)==DB_NOTFOUND) win.clear();
	   win.addEntry(newid);
	   wordsindex->put(&word,&win);    
	}

      //Update sentence index
      QStringList so=sentences(original);
      QStringList st=sentences(translated);
      if(so.count()==st.count() && st.count() >1 ) //we already hav a database for single string.
      {
	  for(int i=0; i< so.count() ; i++)
	  {
	      DBItemMainKey sk(so[i]);
	      DBItemMainKey sd(st[i]); //should be a list
	      sentence->put(&sk,&sd);    
	  
	  } 
      }
      
      
    }

  //Add that translation, link to ref for information on that translation
  if(clean)
    md.removeRef(info->ref());
 if(!translated.isEmpty()) 
  md.addTranslation(translated,info->ref());  

  //finally put!
 return (main->put(&mk,&md)==0);

}



QMap<QString,unsigned int> DataBaseInterface::correlation(QString word,InfoFilter *filter=0)
{
   QMap<QString,unsigned int> res,part;
   DBItemMultiIndex::IndexList il;
   unsigned int tot=0,nocck;
   DBItemMainKey *k = new DBItemMainKey(simple(word));	 
   DBItemMultiIndex *d = new DBItemMultiIndex();	 
   if(wordsindex->get(k,d)!=DB_NOTFOUND)
    {
      il=d->getList();
      tot=il.count();
    for(QValueList<unsigned int>::iterator it=il.begin();it!=il.end();it++)
     {
       numindex->get(*it,k);
       
       
      // QValueList<QueryResult> trad=exactMatch(k->getString(),filter);	   
     
       MainEntry e=get(k->getString(),filter);
      QStringList trad=e.second.getTranslations();      
       
       nocck=words(k->getString()).contains(simple(word));
       for( QStringList::iterator it2=trad.begin();it2!=trad.end();it2++)
       {
       
         QStringList w=words(*it2);
         for(QStringList::iterator it1=w.begin();it1!=w.end();it1++)
         {
	   if(w.contains(*it1)==nocck) //add only if same number of entry (it cuts articles)
   	     res[*it1]++;
              
	 }
	 
       }
     }
      
    }
    unsigned int max=0,max1=0,max2=0;
    QString best,best1,best2;
    for(QMap<QString,unsigned int>::iterator it = res.begin(); it !=res.end(); it++)
    {
     if(it.data()>max) 
               {
		max2=max1;
		best2=best1;
		max1=max;
		best1=best;
	        best = it.key(); 
	        max=it.data();

	       }
  //   if(100*it.data()/tot>30 && tot>20)
	// emit newResult(QueryResult(it.key(),"",100*it.data()/tot)); 
	  
	 

    }
    if(!best.isEmpty()) 
    {
     QueryResult r(format(best,word),i18n("DYNAMIC DICT:"),100*max/tot);
     r.setRichOriginal(i18n("<h3>Dynamic Dictionary</h3>This is a dynamic dictionary created"
		       " looking for correlation of original and translated words.<br>"
		       " <b>Do not rely on it</b>. Translations may be fuzzy.<br>"));
     r.setRichResult("<font size=+2 color=#A00000>"+format(best,word)+"</font>") ;    
     emit newResult(r); 	
    }	
    if(!best1.isEmpty()) 
    {
     QueryResult r(format(best1,word),i18n("DYNAMIC DICT:"),100*max1/tot);
     r.setRichOriginal(i18n("<h3>Dynamic Dictionary</h3>This is a dynamic dictionary created"
		       " looking for correlation of original and translated words.<br>"
		       " <b>Do not rely on it</b>. Translations may be fuzzy.<br>"));
     r.setRichResult("<font size=+2 color=#800000>"+format(best1,word)+"</font>") ;    
     emit newResult(r); 	
    }	
   

    
  return res;
}
QStringList words(QString s)
{
  QString str=simple(s);
  QStringList list;

  int pos;

  do {
    pos=str.find(QRegExp("\\s")); 
    if(!simple(str.left(pos)).isEmpty())
      list.append(simple(str.left(pos)));
    str=str.remove(0,pos+1);
  } while(!str.isEmpty() && pos != -1);

  return list;
}

QString simple(QString str,bool ck)
{
  QString res;
if(ck)
    res=str;  //case keep
else
    res=str.lower();   //lowercase
  res=res.replace(QRegExp("[^\\w\\s-%_]"),""); //strip non-word char

  res=res.simplifyWhiteSpace(); //remove double spaces
  res=res.stripWhiteSpace(); //"  as " -> "as"

  return res;
}

QStringList sentences(QString s)
{
  QString str=s;
  QStringList list;
  
  kdDebug(0) << s << endl;
  
  int pos;

  do {
    pos=str.find(QRegExp("[\\.|;|\\?|\\!]")); 
    if(!str.left(pos).isEmpty());
    list.append(str.left(pos));
    kdDebug(0) << str.left(pos) << endl;
  
    str=str.remove(0,pos+1);
  } while(!str.isEmpty() && pos != -1);

  return list;
}

bool isUpper(QChar s)
{
 return s==s.upper();
}

bool isLower(QChar s)
{
 return s==s.lower();
}



QString format(QString _s,QString t)
{
QString s=_s;

QChar first=t[t.find(QRegExp("\\w"))];
bool firstCapital=isUpper(first);


bool dotsAtEnd=(t.find("...")==t.length()-3);
bool gtgtAtEnd=(t.find(">>")==t.length()-2);
bool ltltAtEnd=(t.find("<<")==t.length()-2);

bool columnAtEnd=(t.find(":")==t.length()-1);

bool allupper=(t.upper()==t);


if(firstCapital)
 s[0]=s[0].upper();
else
 s[0]=s[0].lower();
    
if(dotsAtEnd)
 s+="...";

if(gtgtAtEnd)
 s+=">>";

if(ltltAtEnd)
 s+="<<";

if(columnAtEnd)
 s+=":";

if(allupper)
 s=s.upper();

int pos=t.find(QRegExp("&"));
if(pos>=0) {
   QChar accel=t[t.find(QRegExp("&"))+1];
   if(accel!='&')
   {
       
    pos=s.find(accel,false);
    if(pos<0)
	pos=0;
      s.insert(pos,"&");
  }
 }

return s;

}


//#include "database.moc.cpp"
 
